﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraDockManager1_BeforeToggleDockState(object sender, Infragistics.Win.UltraWinDock.CancelablePaneEventArgs e)
        {
            e.Cancel = true;
            this.RenamePane(e.Pane, this.ActiveControl);
        }

        private void RenamePane(Infragistics.Win.UltraWinDock.DockablePaneBase dockablePaneBase, Control activeControl)
        {

            if (dockablePaneBase.Element == null)
                return;

            UIElement textElement = dockablePaneBase.Element.GetDescendant(typeof(Infragistics.Win.UltraWinDock.PaneCaptionTextAreaUIElement));

            if (textElement == null)
                return;

            Control control = textElement.Control;
            if (control == null)
                return;

            TextBox tb = new TextBox();
            tb.Text = dockablePaneBase.Text;
            tb.Bounds = textElement.Rect;
            control.Controls.Add(tb);
            tb.Focus();

            tb.KeyPress += (p1, p2) =>
                {
                    Keys key = (Keys)p2.KeyChar;
                    if (key == Keys.Enter
                     || key == Keys.Escape)
                    {
                        if (key == Keys.Enter)
                            dockablePaneBase.Text = tb.Text;
                        else
                            tb.Text = dockablePaneBase.Text;

                        p2.Handled = true;
                        control.Controls.Remove(tb);
                        if (activeControl != null)
                            activeControl.Focus();
                    }
                };

            tb.LostFocus += (p1, p2) =>
                {
                    dockablePaneBase.Text = tb.Text;
                    control.Controls.Remove(tb);
                    if (activeControl != null)
                        activeControl.Focus();
                };
        }
    }
}
